package com.magicrf.uhfreader;

import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import android.app.Activity;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewConfiguration;
import android.view.Window;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.Button;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.TextView;
import android.widget.Toast;
import android.zyapi.CommonApi;

import com.android.hdhe.uhf.reader.R;
import com.magicrf.uhfreaderlib.reader.Tools;
import com.magicrf.uhfreaderlib.reader.UhfReader;

public class MainActivity extends Activity implements OnClickListener,
		OnItemClickListener {

	private Button buttonClear;
	private Button buttonConnect;
	private static Button buttonStart;
	private Button button1;
	private TextView textVersion;
	private ListView listViewData;
	private ArrayList<EPC> listEPC;
	private ArrayList<Map<String, Object>> listMap;
	private boolean runFlag = true;
	public static boolean startFlag = false;
	private boolean connectFlag = false;
	private boolean powerOn = false;
	private static String serialPortPath = "/dev/ttyMT2";
	private UhfReader reader; // Ƶд
	private UhfReaderDevice readerDevice; // д豸ץӴдԴ

	private ScreenStateReceiver screenReceiver;
	static CommonApi mCommonApi;
	private static int mComFd = -1;
	MediaPlayer player;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setOverflowShowingAlways();
		setContentView(R.layout.main);
		initView();
		// ȡдʵNull,򴮿ڳʼʧ
		SharedPreferences sharedPortPath = getSharedPreferences("portPath", 0);

		serialPortPath = sharedPortPath.getString("portPath", "/dev/ttyMT2");

		// serialPortPath = "/dev/ttyUSB0";

		mCommonApi = new CommonApi();

		openGPIO();

		try {
			Thread.sleep(2000);
		} catch (InterruptedException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		UhfReader.setPortPath(serialPortPath);

		reader = UhfReader.getInstance();
		// ȡд豸ʾnull豸Դʧ
		readerDevice = UhfReaderDevice.getInstance();
		if (reader == null) {
			textVersion.setText("serialport init fail");
			setButtonClickable(buttonClear, false);
			setButtonClickable(buttonStart, false);
			setButtonClickable(buttonConnect, false);
			return;
		}
		if (readerDevice == null) {
			textVersion.setText("UHF reader power on failed");
			setButtonClickable(buttonClear, false);
			setButtonClickable(buttonStart, false);
			setButtonClickable(buttonConnect, false);
			return;
		}
		try {
			Thread.sleep(100);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// ȡûù,
		SharedPreferences shared = getSharedPreferences("power", 0);
		int value = shared.getInt("value", 26);
		Log.d("", "value" + value);
		reader.setOutputPower(value);

		// powerOn=true;
		// ӹ㲥Ĭʱߣʱ
		screenReceiver = new ScreenStateReceiver();
		IntentFilter filter = new IntentFilter();
		filter.addAction(Intent.ACTION_SCREEN_ON);
		filter.addAction(Intent.ACTION_SCREEN_OFF);
		registerReceiver(screenReceiver, filter);

		button1 = (Button) findViewById(R.id.button1);
		button1.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				if (powerOn) {
					powerOn = false;
					readerDevice.powerOff();
					button1.setText("powerOn");
					Toast.makeText(getApplicationContext(), "power Off", 0)
							.show();
				} else {
					powerOn = true;
					readerDevice.powerOn();
					button1.setText("powerOff");
					Toast.makeText(getApplicationContext(), "power On", 0)
							.show();
				}
			}
		});

		setButtonClickable(buttonConnect, true);

		Thread thread = new InventoryThread();
		thread.start();
		// ʼ
		player = MediaPlayer.create(this, R.raw.msg);

	}

	// gpio
	public static void openGPIO() {
		// TODO Auto-generated method stub

		mCommonApi.setGpioDir(78, 1);
		mCommonApi.setGpioOut(78, 1);

		mCommonApi.setGpioDir(83, 1);
		mCommonApi.setGpioOut(83, 1);

		mCommonApi.setGpioDir(68, 1);
		mCommonApi.setGpioOut(68, 1);
		
		buttonStart.setText(R.string.inventory);

	}

	private void initView() {

		buttonStart = (Button) findViewById(R.id.button_start);
		buttonConnect = (Button) findViewById(R.id.button_connect);
		buttonClear = (Button) findViewById(R.id.button_clear);
		listViewData = (ListView) findViewById(R.id.listView_data);
		textVersion = (TextView) findViewById(R.id.textView_version);
		buttonStart.setOnClickListener(this);
		buttonConnect.setOnClickListener(this);
		buttonClear.setOnClickListener(this);
		setButtonClickable(buttonStart, true);
		setButtonClickable(buttonConnect, false);
		listEPC = new ArrayList<EPC>();
		listViewData.setOnItemClickListener(this);

	}

	// @Override
	// protected void onPause() {
	// = false;
	// super.onPause();
	// }

	/**
	 * ̴߳
	 * 
	 * @author Administrator
	 * 
	 */
	class InventoryThread extends Thread {
		private List<byte[]> epcList;

		@Override
		public void run() {
			super.run();
			while (runFlag) {
				if (startFlag) {
					epcList = reader.inventoryRealTime(); // ʵʱ̴
					if (epcList != null && !epcList.isEmpty()) {
						// ʾ
						player.start();
						for (byte[] epc : epcList) {
							if (epc != null) {
								String epcStr = Tools.Bytes2HexString(epc,
										epc.length);
								addToList(listEPC, epcStr);
							}
						}
					}
					epcList = null;
					try {
						Thread.sleep(40);
					} catch (InterruptedException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
			}
		}
	}

	// ȡEPCӵLISTVIEW
	private void addToList(final List<EPC> list, final String epc) {
		runOnUiThread(new Runnable() {
			@Override
			public void run() {
				// һζ
				if (list.isEmpty()) {
					EPC epcTag = new EPC();
					epcTag.setEpc(epc);
					epcTag.setCount(1);
					list.add(epcTag);
				} else {
					for (int i = 0; i < list.size(); i++) {
						EPC mEPC = list.get(i);
						// listдEPC
						if (epc.equals(mEPC.getEpc())) {
							mEPC.setCount(mEPC.getCount() + 1);
							list.set(i, mEPC);
							break;
						} else if (i == (list.size() - 1)) {
							// listûдepc
							EPC newEPC = new EPC();
							newEPC.setEpc(epc);
							newEPC.setCount(1);
							list.add(newEPC);
						}
					}
				}
				// ӵListView
				listMap = new ArrayList<Map<String, Object>>();
				int idcount = 1;
				for (EPC epcdata : list) {
					Map<String, Object> map = new HashMap<String, Object>();
					map.put("ID", idcount);
					map.put("EPC", epcdata.getEpc());
					map.put("COUNT", epcdata.getCount());
					idcount++;
					listMap.add(map);
				}
				listViewData.setAdapter(new SimpleAdapter(MainActivity.this,
						listMap, R.layout.listview_item, new String[] { "ID",
								"EPC", "COUNT" }, new int[] { R.id.textView_id,
								R.id.textView_epc, R.id.textView_count }));
			}
		});
	}

	// ðťǷ
	private void setButtonClickable(Button button, boolean flag) {
		button.setClickable(flag);
		if (flag) {
			button.setTextColor(Color.BLACK);
		} else {
			button.setTextColor(Color.GRAY);
		}
	}

	// رgpio
	public static void closeGPIO() {

		mCommonApi.setGpioDir(78, 1);
		mCommonApi.setGpioOut(78, 0);

		 mCommonApi.setGpioDir(83, 1);
		 mCommonApi.setGpioOut(83,0);
		 
		 mCommonApi.setGpioDir(68, 1);
		 mCommonApi.setGpioOut(68,0);

	}

	@Override
	protected void onDestroy() {
		runFlag = false;
		if (reader != null) {
			reader.close();
		}
		if (readerDevice != null) {
			readerDevice.powerOff();
		}
		// unregisterReceiver(screenReceiver);
		closeGPIO();
		mCommonApi.closeCom(mComFd);
		Log.e("ٽ", "ٽ");
		super.onDestroy();
	}

	/**
	 * listview
	 */
	private void clearData() {
		listEPC.removeAll(listEPC);
		listViewData.setAdapter(null);
	}

	@Override
	public void onClick(View v) {

		switch (v.getId()) {
		case R.id.button_start:
			if (!startFlag) {
				startFlag = true;
				buttonStart.setText(R.string.stop_inventory);
			} else {
				startFlag = false;
				buttonStart.setText(R.string.inventory);
			}
			break;
		case R.id.button_connect:

			byte[] versionBytes = reader.getFirmware();
			if (versionBytes != null) {
				// reader.setWorkArea(3);//óŷ
				player.start();
				// String version = new String(versionBytes);
				// textVersion.setText(new String(versionBytes));
				setButtonClickable(buttonConnect, false);
				setButtonClickable(buttonStart, true);
			}
			setButtonClickable(buttonConnect, false);
			setButtonClickable(buttonStart, true);
			break;

		case R.id.button_clear:
			clearData();
			break;
		default:
			break;
		}
	}

	private int value = 2600;

	// private int values = 432 ;
	// private int mixer = 0;
	// private int if_g = 0;

	@Override
	public void onItemClick(AdapterView<?> adapter, View view, int position,
			long id) {
		TextView epcTextview = (TextView) view.findViewById(R.id.textView_epc);
		String epc = epcTextview.getText().toString();
		// ѡEPC
		// reader.selectEPC(Tools.HexString2Bytes(epc));

		Toast.makeText(getApplicationContext(), epc, 0).show();
		Intent intent = new Intent(this, MoreHandleActivity.class);
		intent.putExtra("epc", epc);
		startActivity(intent);
	}

	@Override
	public boolean onMenuItemSelected(int featureId, MenuItem item) {
		// Log.e("", "adfasdfasdf");
		// Intent intent = new Intent(this, SettingActivity.class);
		// startActivity(intent);
		Intent intent = new Intent(this, SettingPower.class);
		startActivity(intent);
		return super.onMenuItemSelected(featureId, item);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		getMenuInflater().inflate(R.menu.main, menu);

		return true;
	}

	@Override
	public boolean onMenuOpened(int featureId, Menu menu) {
		if (featureId == Window.FEATURE_ACTION_BAR && menu != null) {
			if (menu.getClass().getSimpleName().equals("MenuBuilder")) {
				try {
					Method m = menu.getClass().getDeclaredMethod(
							"setOptionalIconsVisible", Boolean.TYPE);
					m.setAccessible(true);
					m.invoke(menu, true);
				} catch (Exception e) {
				}
			}
		}
		return super.onMenuOpened(featureId, menu);
	}

	/**
	 * actionbarʾ˵ť
	 */
	private void setOverflowShowingAlways() {
		try {
			ViewConfiguration config = ViewConfiguration.get(this);
			Field menuKeyField = ViewConfiguration.class
					.getDeclaredField("sHasPermanentMenuKey");
			menuKeyField.setAccessible(true);
			menuKeyField.setBoolean(config, false);

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		// TODO Auto-generated method stub
		if (keyCode == KeyEvent.KEYCODE_F1) {
			if (!startFlag) {
				startFlag = true;
				buttonStart.setText(R.string.stop_inventory);
			} else {
				startFlag = false;
				buttonStart.setText(R.string.inventory);
			}
		}
		return super.onKeyDown(keyCode, event);
	}

}
